=== debian/changelog ===
ovito (2.8.1+dfsg2-5) unstable; urgency=medium

  * [eb12b49] Block tests on mips nd mips64el.

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Jan 2017 16:01:02 +0100

ovito (2.8.1+dfsg2-4) unstable; urgency=medium

  * [eb599c6] Override autotest on armel und s390x

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Jan 2017 10:05:07 +0100

ovito (2.8.1+dfsg2-3) unstable; urgency=medium

  [ Ghislain Antony Vaillant ]
  * [79e635e] Add missing repack settings
  * [31d5c07] Filter tarball from vendored pybind11
  * [ea3daac] Bump repack suffix
  * [4d2618b] New upstream version 2.8.1+dfsg2
  * [262c086] Use numbered patch queue
  * [7793150] Renumber current patch queue
  * [b7face1] Cherry-pick upstream fix for parallel execution of tests
  * [aec42f3] Cherry-pick upstream fix for tests for builds without
              CrystanAnalysis
  * [e1b2e36] Build with the system pybind11
              d/control: add pybind11-dev to b-deps
  * [e24b444] Drop bypass of test failures

 -- Anton Gladky <gladk@debian.org>  Sat, 14 Jan 2017 15:09:23 +0100

ovito (2.8.1+dfsg1-2) unstable; urgency=medium

  * [f0b0b49] Disable unit-test failures.

 -- Anton Gladky <gladk@debian.org>  Sun, 08 Jan 2017 18:56:50 +0100

ovito (2.8.1+dfsg1-1) unstable; urgency=medium

  [ Ghislain Antony Vaillant ]
  * [72aa97b] Fix "No files matched excluded pattern" reported by uscan
  * [8480ecd] Update watch file

  [ Anton Gladky ]
  * [2aa0adf] Remove patch applied by upstream.
  * [0a4cca5] Refresh patch.
  * [cf985df] Minor fixes in d/copyright.
  * [47c0aff] New upstream version 2.8.1+dfsg1. (Closes: #848761)

 -- Anton Gladky <gladk@debian.org>  Sun, 08 Jan 2017 15:50:21 +0100

ovito (2.8.0+dfsg2-2) unstable; urgency=medium

  * [443ab04] Disable Crystall plugin on s390x ppc64el arm64

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Dec 2016 19:48:12 +0100

ovito (2.8.0+dfsg2-1) unstable; urgency=medium

  * [739dfb4] Use system qwt insteaf of embedded.
  * [6a39019] Remove embedded jquery.js.
  * [623eee4] New upstream version 2.8.0+dfsg2

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Dec 2016 14:24:27 +0100

ovito (2.8.0+dfsg1-1) unstable; urgency=medium

  * [92617b4] Update/remove patches.
  * [91d0b2a] Update build dependencies.
  * [c0cfff8] Update d/copyright.
  * [6f351ea] Update d/watch
  * [0ab031b] New upstream version 2.8.0+dfsg1
  * [3e0c4ac] Apply cme fix dpkg.

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Dec 2016 00:21:45 +0100
