=== debian/control ===
Source: ovito
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Testsuite: autopkgtest
Priority: extra
Build-Depends: cmake,
               debhelper (>= 9),
               docbook-xml,
               docbook-xsl,
               docbook-xsl-doc-html,
               libavcodec-dev,
               libavdevice-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-python-dev,
               libbotan1.10-dev,
               libcgal-qt5-dev [!armel],
               libglu1-mesa-dev [armel armhf],
               libgl1-mesa-dev [armel armhf],
               libgsl0-dev,
               libhdf5-dev,
               libmuparser-dev,
               libnetcdf-dev,
               libqt5scintilla2-dev,
               libqt5opengl5-dev,
               libqcustomplot-dev,
               libqwt-qt5-dev,
               libswscale-dev,
               povray,
               pybind11-dev,
               python-dev,
               python3-sphinx,
               python3-matplotlib,
               python3-sip,
               python3-numpy,
               python3-pyqt5,
               qtbase5-dev-tools,
               qtscript5-dev,
               xsltproc,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ovito.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ovito.git
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any
Depends: python,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ovito-doc
Suggests: povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: ovito
Provides: ovito-examples
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.
