=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt5
%:
	dh $@ --parallel

extra_flags += \
	-DOVITO_BUILD_DOCUMENTATION=TRUE \
	-DOVITO_BUILD_PLUGIN_SCRIPTING=TRUE \
	-DOVITO_BUILD_PLUGIN_NETCDF=TRUE \
	-DOVITO_VIDEO_OUTPUT_SUPPORT=ON \
	-DOVITO_USE_SYSTEM_QCUSTOMPLOT=ON \
	-DOVITO_BUILD_PLUGIN_TACHYON=ON

ifeq (,$(filter $(DEB_HOST_ARCH), armel s390x ppc64el arm64))
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=TRUE
else
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=FALSE
endif

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_install-arch:
	dh_install -a --list-missing
	find ./debian/ovito -type d -empty -delete
	find ./ -name "*DS_Store" | xargs rm -f
	find . -name '__pycache__' -print0 | xargs -0 rm -rf
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_install-indep:
	dh_install -i
	dh_sphinxdoc

ifneq (,$(filter $(DEB_HOST_ARCH), armel s390x mips mips64el))
override_dh_auto_test:
	dh_auto_test || true
endif
